clear
program drop _all
set memory 300m
set more 1
log using autounion_riflogit.log, replace

*define the program to compute the density at every fifth quantile
     program define densqt
      quietly{
        local qt = `1'
        local uq = `2'
        local step = `3'
        
        
        gen xvar = lwage
        pctile eval=xvar, nq(100)
        kdensity xvar, at(eval) gen(eval1 dens1) width(0.06) nograph
	while `qt'<`uq' {         
                gen fden`qt'=dens1[`qt']
                gen x`qt'=eval1[`qt']                
       local qt = `qt' + `step'
      }
    }
    display "densqt done"
    end

*define the program to do logit unquant regression
    program define lgucqnt

        local qt = `1'
        local uq = `2'
	while `qt'<`uq' {
                local qc = `qt'/100.0
                use men8385_dens
                gen depv=1 if lwage>= x`qt'
                replace depv=0 if lwage< x`qt'
       quietly  logit depv covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9, robust 
                predict lpr, xb
                gen denom=(1+exp(lpr))^2
                gen plpr=exp(lpr)/denom
                sum plpr
                gen mplpr=r(mean)/fden`qt'
                scalar md=mplpr
                matrix BM=e(b)*md
                svmat double BM, name(blgvec)
**** do discrete change
                gen temp=covered
                replace covered=0
                predict pr0, pr
                replace covered=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg1=r(mean)
                replace covered=temp
                drop pr0 pr1 dpr temp
********
                gen temp=nonwhite
                replace nonwhite=0
                predict pr0, pr
                replace nonwhite=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg2=r(mean)
                replace nonwhite=temp
                drop pr0 pr1 dpr temp
********
                gen temp=marr
                replace marr=0
                predict pr0, pr
                replace marr=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg3=r(mean)
                replace marr=temp
                drop pr0 pr1 dpr temp
****** 
                gen temp1=ed0
                gen temp2=ed1
                gen temp3=ed3
                gen temp4=ed4
                gen temp5=ed5
                replace ed0=0
                replace ed1=0
                replace ed3=0
                replace ed4=0
                replace ed5=0
                predict pr0, pr
                replace ed0=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg4=r(mean)
                drop pr1 dpr 
                replace ed0=0
                replace ed1=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg5=r(mean)
                drop pr1 dpr 
                replace ed1=0
                replace ed3=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg6=r(mean)
                drop pr1 dpr 
                replace ed3=0
                replace ed4=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg7=r(mean)
                drop pr1 dpr 
                replace ed4=0
                replace ed5=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg8=r(mean)
                replace ed0=temp1
                replace ed1=temp2
                replace ed3=temp3
                replace ed4=temp4
                replace ed5=temp5
                drop pr0 pr1 dpr temp1 temp2 temp3 temp4 temp5
****** 
                gen temp1=ex1
                gen temp2=ex2
                gen temp3=ex3
                gen temp4=ex4
                gen temp5=ex6
                gen temp6=ex7
                gen temp7=ex8
                gen temp8=ex9
                replace ex1=0
                replace ex2=0
                replace ex3=0
                replace ex4=0
                replace ex6=0
                replace ex7=0
                replace ex8=0
                replace ex9=0
                predict pr0, pr
                replace ex1=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg9=r(mean)
                drop pr1 dpr 
                replace ex1=0
                replace ex2=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg10=r(mean)
                drop pr1 dpr 
                replace ex2=0
                replace ex3=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg11=r(mean)
                drop pr1 dpr 
                replace ex3=0
                replace ex4=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg12=r(mean)
                drop pr1 dpr 
                replace ex4=0
                replace ex6=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg13=r(mean)
                drop pr1 dpr 
                replace ex6=0
                replace ex7=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg14=r(mean)
                drop pr1 dpr 
                replace ex7=0
                replace ex8=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg15=r(mean)
                drop pr1 dpr 
                replace ex8=0
                replace ex9=1
                predict pr1, pr
                gen dpr=(pr1-pr0)/fden`qt'
                sum dpr
                gen amlg16=r(mean)
                replace ex1=temp1
                replace ex2=temp2
                replace ex3=temp3
                replace ex4=temp4
                replace ex6=temp5
                replace ex7=temp6
                replace ex8=temp7
                replace ex9=temp8
                drop pr0 pr1 dpr temp1 temp2 temp3 temp4 temp5 temp6 temp7 temp8
******                
                gen qtau=`qt'/100
                keep qtau blgvec* amlg*
                drop if blgvec1==.
                append using lgucqtcf
                save lgucqtcf,replace
                clear
                local qt = `qt' + 5
      }
    display "lgunquant done"
    end


*begin with Men 1983-85

use men8385


*** begin with OLS
reg lwage covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9, robust 
matrix B=e(b)
svmat double B, name(blpvec)
matrix VCB=e(V)
matrix VB=vecdiag(VCB)
svmat double VB, name(vblpv)
gen qtau=0.0  /* store OLS in the zero and one quantile*/
keep qtau blpvec* vblpv*
drop if blpvec1==.
expand 2
replace qtau=1.0 if _n>1
save lgucqtcf, replace
clear
****begin with computation of dens and x
use men8385
densqt 5 100 5 
save men8385_dens,replace
***** do logit uncqt
lgucqnt 5 100

                
                
                




