clear
program drop _all
set memory 500m
set more 1
log using autounion_uqr_boot.log, replace

*define the program to compute the density at every fifth quantile
     program define densqt
      quietly{
        local qt = `1'
        local qc= `qt'/100
        gen xvar = lwage
        pctile eval=xvar, nq(100)
        kdensity xvar, at(eval) gen(eval1 dens1) gaussian width(0.06) nograph
	  gen fden`qt'=dens1[`qt']
        gen x`qt'=eval1[`qt']
        gen rif_p`qt'=eval1[`qt']+`qc'/fden`qt' if lwage>=eval1[`qt']
        replace rif_p`qt'=eval1[`qt']-(1-`qc')/fden`qt' if lwage<eval1[`qt']                   
    }
    display "densqt done"
    end

*define the program to do unconditional quantile regression with bootstrap std
    program define bsuncqt
        
        tempfile BOOTMST BOOTRES
        tempname coefs VCE adj
        local qt = `1'
        local uq = `2'
        local reps = `3'

	
	while `qt'<`uq' {
                local qc = `qt'/100.0
                use men8385_9
                keep lwage covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9
                save "`BOOTMST'", replace
* keep the coefficients estimated first
                di "estimating quantile "  `qt'
                densqt `qt'
      quietly  {
                reg rif_p`qt' covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9, robust 
                matrix B=e(b)
                svmat double B, name(bvector)                
                }   
*end of quietly
******                
                gen qtau=`qt'/100
                keep qtau bvector* 
                drop if bvector1==.
                save "`BOOTRES'", replace
                append using  bsuqcf
                sort qtau
                drop if qtau==qtau[_n-1]
                save  bsuqcf,replace

               *** bootstrap loop
                di "bootstrap loop"
                local j 1                     
         while `j'<= (`reps'-1) {                 
                di `j'  
                use "`BOOTMST'", clear
                bsample
                densqt `qt'                
       quietly  {
                reg rif_p`qt' covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9, robust 
                matrix B=e(b)
                svmat double B, name(bvector)                
              } 
*end quietly
******                
                gen qtau=`qt'/100
                keep qtau bvector* 
        quietly { 
                keep if _n==1
                append using "`BOOTRES'"
                save "`BOOTRES'", replace
                }
                local j = `j' + 1
          clear
                }
      * end of bsloop
                use "`BOOTRES'"
                matrix accum `VCE' = bvector*, dev nocons
                scalar `adj' = 1/(`reps'-1)
                mat `VCE'=`VCE'*`adj'
                matrix VB=vecdiag(`VCE')
                svmat double VB, name(vbvec)
                keep qtau vbvec*
        quietly {
                drop if vbvec1==.
                sort qtau
                merge qtau using  bsuqcf
                drop _merge
                sort qtau
                save  bsuqcf, replace
                }
          local qt = `qt' + 5
      }
    display "lgunquant done"
    end

*Use models with set of dummies;


*********Model for 1983-85, men **************;
use men8385
reg lwage covered nonwhite marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9, robust 
matrix B=e(b)
svmat double B, name(bvector)
matrix VCB=e(V)
matrix VB=vecdiag(VCB)
svmat double VB, name(vbvtor)
gen qtau=0.0  /* store OLS in the zero and one quantile*/
keep qtau bvector* vbvtor*
drop if bvector1==.
expand 2
replace qtau=1.0 if _n>1
save bsuqcf, replace
clear
*******
** now do for the unconditional quantiles 5 to 95
***
***** do uncqt
bsuncqt 5 100 200
                
                
                




