clear
program drop _all
set memory 450m
set matsize 600
set more 1
log using npmen8385_25.log, replace


*begin with Men 1983-85
use men8385


gen edc=0 if educ<9
replace edc=1 if educ<12 & educ>=9
replace edc=2 if educ>=12 & educ<13
replace edc=3 if educ>=13 & educ<=15 
replace edc=4 if educ==16
replace edc=5 if educ>16

gen exc=1 if exper<5 
replace exc=2 if exper>=5 & exper<10 
replace exc=3 if exper>=10 & exper<15 
replace exc=4 if exper>=15 & exper<20 
replace exc=5 if exper>=20 & exper<25 
replace exc=6 if exper>=25 & exper<30 
replace exc=7 if exper>=30 & exper<35 
replace exc=8 if exper>=35 & exper<40 
replace exc=9 if exper>=40 

gen cov=covered
rename nonwhite now

gen cell=1000*now+100*marr+10*edc+exc

tab cell, gen(ce)
compress ce*

forvalues i=1/215{
  gen byte uce`i'=cov*ce`i'
}
*drop uce55 uce109 uce162 uce163


forvalues j=25/25{
gen xvar = lwage
pctile eval=xvar, nq(100)
kdensity xvar, at(eval) gen(eval1 dens1) width(0.06) gaussian nograph
gen fdens`j'=dens1[`j']
gen x`j'=eval1[`j']
local jc = `j'/100.0
gen rif=x`j'+`jc'/fdens`j' if lwage>=x`j'
replace rif=x`j'-(1-`jc')/fdens`j' if lwage<x`j'
gen depv=1 if lwage>= x`j'
replace depv=0 if lwage<x`j'
}

replace cov=covered
forvalues i=1/215{
  quietly replace uce`i'=cov*ce`i'
}

logit depv cov now marr ed0 ed1 ed3 ed4 ed5 ex1-ex4 ex6-ex9 [pweight=eweight] , robust
 gen temp=cov
 replace cov=0
 predict pr0, pr
 replace cov=1
 predict pr1, pr
 gen dpr=(pr1-pr0)/fden`j'
 sum dpr
 replace cov=temp
 drop pr0 pr1 dpr temp


*logit depv cov ce2-ce215 uce2-uce215 [pweight=eweight] , robust
* full specification above modified for missing cells 
logit depv cov ce2-ce159 ce163-ce214 /*
   */ uce2-uce43 uce46-uce53 /*
   */ uce55-uce108  /*
   */ uce110-uce123 uce125-uce140 uce141 /*
   */ uce142-uce143 uce145-uce150 uce154-uce157  /*
   */ uce164-uce170 uce172-uce206  /*
   */ uce208-uce213 /*
   */ [pweight=eweight] , robust

replace cov=0
forvalues i=1/215{
  quietly replace uce`i'=cov*ce`i'
}
predict prlog_0

replace cov=1
forvalues i=1/215{
 quietly replace uce`i'=cov*ce`i'
}

predict prlog_1
gen dcovl=(prlog_1-prlog_0)/fdens`j'
sum dcovl

*compare with rifreg with same specification
replace cov=covered
reg rif cov now marr ed0 ed1 ed3 ed4 ed5 /*
 */ex1-ex4 ex6-ex9 [aweight=eweight] , robust


forvalues i=1/215{
 quietly  replace uce`i'=cov*ce`i'
}

*reg rif  cov ce2-ce215 uce2-uce215 [aweight=eweight] , robust
reg rif cov ce2-ce159 ce163-ce214 /*
   */ uce2-uce43 uce46-uce53 /*
   */ uce55-uce108  /*
   */ uce110-uce123 uce125-uce140 uce141 /*
   */ uce142-uce143 uce145-uce150 uce154-uce157  /*
   */ uce164-uce170 uce172-uce206  /*
   */ uce208-uce213 /*
   */ [aweight=eweight] , robust

replace cov=0
forvalues i=1/215{
  quietly replace uce`i'=cov*ce`i'
}

predict prif_0

replace cov=1
forvalues i=1/215{
 quietly replace uce`i'=cov*ce`i'
}


predict prif_1
gen dcovr=prif_1-prif_0
sum dcovr
drop dcovr prif_0 prif_1

